#!/usr/bin/perl
#
# Module Uncompressor, Compiler and Installer
#
# Este script trata un archivo comprimido (tgz,tar.bz2,etc) lo descomprime 
# en un directorio (a indicar o en /tmp), lo compila (mediante la 
# instruccion que se le de y lo instala (mediante la instruccin pertinente).
#
# Normalmente har falta tener un kenel en cdigo fuente, configurado 
# y compilado para poder compilar el mdulo.
#
#  Uso: mod_uci.pl -f <file> -c <compilation> -i <installation>
#
#############################################################################
#

use Getopt::Std;

getopts("f:sc:si:s",\%args);

$file=$args{f};
$compile=$args{c};
$install=$args{i};
$directory=$args{d};
`rm -rf /tmp/mod_uci/`;
$directory="/tmp/mod_uci/";

if(!$file or !$compile or !$install or !$directory){
  print "\nUso: mod_uci.pl -f <file> -c <compilation> -i <installation>\n\n";
  print "\tParametros:\n";
  print "\t-f <file> : Fichero fuente del mdulo\n";
  print "\t-c <compilation>: Comando para compilar el mdulo\n";
  print "\t-i <installation>: Comando para instalar el mdulo\n\n";
  exit 1;
}

%uncompress=( 	"tar.bz2"	=> "tar -xjf",
		"bz2"		=> "bzip2 -d",
		"gz"		=> "gzip -d",
		"tar"		=> "tar -xf",
		"tbz"		=> "tar -xjf",
		"zip"		=> "unzip",
		"tgz"		=> "tar -xzf");
$long=0;
foreach $exten(keys %uncompress){
  if( $exten =~ m/.+\..+$/ ){
     $file=~ m/^(.+)\.(.+)\.(.+)$/ ;
     $fexten=$2.".".$3;
  }else{
     $file=~ m/^(.+)\.(.+)$/ ;
     $fexten=$2;
  }
  if ( "$fexten" eq "$exten" ) {
     if(length($fexten)>$long){
	$tipof=$fexten;
     }
  }
}

$comando=$uncompress{$tipof};
#print "El fichero $file se descomprime con \"".$uncompress{$tipof}."\"\n";

mkdir $directory;
chdir $directory or die "No se pudo cambiar al directorio $directory";
print "Descomprimiendo $file con $comando\n\n";
open (UNC_RES,"$comando $file|") or die "No se pudo ejecutar $comando $file";
@unc_res=<UNC_RES>;
print @unc_res;
close(UNC_RES);

opendir(DIR,$directory);
@dirs=readdir(DIR);
$nuevo_dir=$dirs[2];
#print "Cambiando a $nuevo_dir\n";
chdir $nuevo_dir or die "No se pudo cambiar a $nuevo_dir";

open (COMP_RES,"$compile|") or die "No se pudo ejecutar $compile";
@comp_res=<COMP_RES>;
print @comp_res;
close(COMP_RES);

open (INST_RES,"$install|") or die "No se pudo ejecutar $install";
@inst_res=<INST_RES>;
print @inst_res;
close(INST_RES);
